/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * Portions created by Devexperts are Copyright (C) 2007-2012 Devexperts.
 */

package com.devexperts.evolution.utils.configencoder;

import java.beans.*;

/**
 * Default persistence delegate for enums.
 *
 * @author Lukashevich Sergey
 */
public class EnumPersistenceDelegate extends PersistenceDelegate {
    private static final EnumPersistenceDelegate INSTANCE = new EnumPersistenceDelegate();

    private EnumPersistenceDelegate() {
    }

    public static EnumPersistenceDelegate getInstance() {
        return INSTANCE;
    }

    @Override
    protected boolean mutatesTo(Object oldInstance, Object newInstance) {
        return oldInstance == newInstance;
    }

    @Override
    protected Expression instantiate(Object oldInstance, Encoder out) {
        Enum<?> e = (Enum<?>) oldInstance;
        return new Expression(e.getDeclaringClass(), "valueOf", new Object[]{e.getDeclaringClass(), e.name()});
    }
}
