/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * Portions created by Devexperts are Copyright (C) 2007-2012 Devexperts.
 */

package com.devexperts.evolution.utils.configencoder;

/**
 * @author Anton V. Shakhmin
 */
class Lexeme {
    public static final int UNKNOWN = 0;
    public static final int BOOLEAN = 1;
    public static final int BYTE = 2;
    public static final int SHORT = 3;
    public static final int INT = 4;
    public static final int LONG = 5;
    public static final int FLOAT = 6;
    public static final int DOUBLE = 7;
    public static final int CHAR = 8;
    public static final int STRING = 9;
    public static final int NULL = 10;
    public static final int ENUM = 11;
    public static final int CLASS_OR_FIELD = 12;

    public static final int ALIAS_SIGN = 13;

    public static final int NAME = 14;
    public static final int NEW_INSTANCE_SIGN = 15;
    public static final int ARRAY_DIMENSION = 16;
    public static final int OBJECT_REF = 17;

    public static final int COMMA = 18;
    public static final int LEFT_BRACE = 19;
    public static final int RIGHT_BRACE = 20;
    public static final int LEFT_PARENTHESIS = 21;
    public static final int RIGHT_PARENTHESIS = 22;
    public static final int COLON = 23;
    public static final int EQUALS_SIGN = 24;

    public static final int PLUS_SIGN = 25;
    public static final int DEGREE_SIGN = 26;
    public static final int EXCLAMATION_MARK = 27;
    public static final int DIMENSION_IN_ARRAY_TYPE = 28;

    private int type;
    private String value;

    public Lexeme() {
        this.type = UNKNOWN;
        this.value = null;
    }

    public Lexeme(int type, String value) {
        this.type = type;
        this.value = value;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }
}
