/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * Portions created by Devexperts are Copyright (C) 2007-2012 Devexperts.
 */

package com.devexperts.evolution.utils.configencoder;

/**
 * @see DefaultNameConverter
 *
 * @author Anton V. Shakhmin
 */
public class MappingRule {
    protected final String oldName;
    protected final String newName;
    protected final String className;

    public MappingRule(String oldName, String newName, String className) {
        this.newName = newName;
        this.oldName = oldName;
        this.className = className;
    }

    public String getOldName() {
        return oldName;
    }

    public String getNewName() {
        return newName;
    }

    public String getClassName() {
        return className;
    }

    protected boolean demapMethodMatchClass(String className, Object target) {
        // this default implementation is REALLY funny - it only consideres simple class name, NOT the whole class name
        return DefaultNameConverter.getClassSimpleName(this.className).equals(DefaultNameConverter.getClassSimpleName(className));
    }
}
