/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * Portions created by Devexperts are Copyright (C) 2007-2012 Devexperts.
 */

package com.devexperts.evolution.utils.configencoder;

class Utils {

    static String extractPackageName(String name) {
        int pos = name.lastIndexOf('.');
        return pos == -1 ? "" : name.substring(0, pos);
    }

    static String extractClassName(String name) {
        int pos = name.lastIndexOf('.');
        return pos == -1 ? "" : name.substring(pos + 1);
    }

    /*static String getArrayElementType(String aType) {
        String res = null;
        int i = aType.lastIndexOf('[') + 1;
        if (aType.charAt(i) == 'Z') {
            res = "boolean";
        } else if (aType.charAt(i) == 'B') {
            res = "byte";
        } else if (aType.charAt(i) == 'C') {
            res = "char";
        } else if (aType.charAt(i) == 'D') {
            res = "double";
        } else if (aType.charAt(i) == 'F') {
            res = "float";
        } else if (aType.charAt(i) == 'I') {
            res = "int";
        } else if (aType.charAt(i) == 'J') {
            res = "long";
        } else if (aType.charAt(i) == 'S') {
            res = "short";
        } else if (aType.charAt(i) == 'L') {
            res = aType.substring(i + 1, aType.length() - 1);
        }
        return res;
    }*/

    static Class getArrayComponentClass(Class componentClass) {
        while (componentClass.isArray()) {
            componentClass = componentClass.getComponentType();
        }
        return componentClass;
    }

    static Class primitiveTypeFor(Class<?> wrapper) {
        if (wrapper == Boolean.class) {
            return Boolean.TYPE;
        }
        if (wrapper == Byte.class) {
            return Byte.TYPE;
        }
        if (wrapper == Character.class) {
            return Character.TYPE;
        }
        if (wrapper == Short.class) {
            return Short.TYPE;
        }
        if (wrapper == Integer.class) {
            return Integer.TYPE;
        }
        if (wrapper == Long.class) {
            return Long.TYPE;
        }
        if (wrapper == Float.class) {
            return Float.TYPE;
        }
        if (wrapper == Double.class) {
            return Double.TYPE;
        }
        if (wrapper == Void.class) {
            return Void.TYPE;
        }
        return null;
    }

    static boolean isNanOrInfinity(Object value) {
        Class primitiveType = primitiveTypeFor(value.getClass());
        if (primitiveType != null) {
            if (primitiveType == Float.TYPE) {
                Float f = (Float)value;
                if (f.isNaN() || f == Float.POSITIVE_INFINITY || f == Float.NEGATIVE_INFINITY) {
                    return true;
                }
            } else if (primitiveType == Double.TYPE) {
                Double d = (Double)value;
                if (d.isNaN() || d == Double.POSITIVE_INFINITY || d == Double.NEGATIVE_INFINITY) {
                    return true;
                }
            }
        }
        return false;
    }

    static boolean isPrimitiveWrapper(Class cl) {
        return cl == Boolean.class || cl == Byte.class || cl == Character.class || cl == Short.class
            || cl == Integer.class || cl == Long.class || cl == Float.class || cl == Double.class || cl == Void.class;
    }
}
